#include <bits/stdc++.h>
using namespace std;

int N = 1e5+15;

int ft_n = N; // O(n)
vector<int> ftree(ft_n, 0); // 1-indexed

void add /* O(lg n) */ (int i, int d) {
  for (; i < ft_n; i += i & -i)
    ftree[i] += d;
}

int query /* O(lg n) */ (int i) {
  int sum = 0;
  for (; i > 0; i -= i & -i)
    sum += ftree[i];
  return sum;
}

int query_exclusive /* O(lg n) */ (int i, int j) {
  return query(j-1) - query(i-1);
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n;
    cin >> n;

    string numbers;
    cin >> numbers;

    for (int i = 0; i < n; i++) {
        add(i+1, numbers[i]-'0');
    }

    int q;
    cin >> q;
    while (q--) {
        int op;
        cin >> op;

        if (op == 3) {
            int p;
            cin >> p;
            p--;

            int d;
            cin >> d;

            add(p+1, d-int(numbers[p]-'0'));
            numbers[p] = char(d+'0');
        } else {
            int a1, b1;
            cin >> a1 >> b1;

            int sum1 = (query_exclusive(a1, b1+1)) % 9;

            int a2, b2;
            cin >> a2 >> b2;

            int sum2 = (query_exclusive(a2, b2+1)) % 9;

            int r;
            if (op == 1) {
                r = (sum1 + sum2) % 9;
            } else {
                r = (sum1 * sum2) % 9;
            }

            int d;
            cin >> d;

            if (d == r) {
                cout << "YES\n";
            } else {
                cout << "NO\n";
            }
        }
    }
}
